---
title: Firefox 2 for developers
slug: Mozilla/Firefox/Releases/2
tags:
  - Firefox
  - Firefox 2
---
<div>{{FirefoxSidebar}}</div><h2 id="New_developer_features_in_Firefox_2">New developer features in Firefox 2</h2>

<p>Firefox 2 introduces a vast array of new features and capabilities. This article provides links to articles covering the new features.</p>

<h3 id="For_web_site_and_application_developers">For web site and application developers</h3>

<dl>
 <dt><a class="external" href="http://wiki.mozilla.org/Microsummaries">Microsummaries</a></dt>
 <dd>Microsummaries are regularly-updated succinct compilations of the most important information on web pages. Site and third-party developers can both provide them, and users can choose to display microsummaries instead of static titles when they bookmark pages with microsummaries.</dd>
 <dt><a href="/en-US/docs/Creating_a_Microsummary">Creating a Microsummary</a></dt>
 <dd>A tutorial on creating a microsummary generator.</dd>
 <dt><a href="/en-US/docs/Microsummary_XML_grammar_reference">Microsummary XML grammar reference</a></dt>
 <dd>A reference guide to the XML grammar used for creating microsummary generators.</dd>
 <dt><a href="/en-US/docs/Creating_OpenSearch_plugins_for_Firefox">Creating OpenSearch plugins for Firefox</a></dt>
 <dd>Firefox 2 supports the OpenSearch search engine format.</dd>
 <dt><a href="/en-US/docs/Creating_MozSearch_plugins">Creating MozSearch plugins</a></dt>
 <dd>Firefox 2 supports MozSearch, a search plugin format based on OpenSearch, but intended only for internal use.</dd>
 <dt><a href="/en-US/docs/Supporting_search_suggestions_in_search_plugins">Supporting search suggestions in search plugins</a></dt>
 <dd>How to make your MozSearch plugin support search suggestions, which appear in a drop-down list while typing in the search bar.</dd>
 <dt><a href="/en-US/docs/New_in_JavaScript_1.7">New in JavaScript 1.7</a></dt>
 <dd>Firefox 2 supports JavaScript 1.7, which includes new features including <code>let</code>, destructuring assignment, generators and iterators, and array comprehensions.</dd>
 <dt><a href="/en-US/docs/DOM/Storage">WHATWG Client-side session and persistent storage (aka DOM Storage)</a></dt>
 <dd>Client-side session and persistent storage allows web applications to store structured data on the client side.</dd>
 <dt><a href="/en-US/docs/SVG_in_Firefox">SVG in Firefox</a></dt>
 <dd>Firefox 2 improves Scalable Vector Graphics (SVG) support, implementing the <code>&lt;textPath&gt;</code> element and adding support for some attributes not previously supported.</dd>
 <dt><a href="/en-US/docs/Controlling_spell_checking_in_HTML_forms">Controlling spell checking in HTML forms</a></dt>
 <dd>Firefox 2 includes support for inline spell checking in text areas and text fields. This article describes how to write your HTML to enable and disable spell checking on individual form elements.</dd>
</dl>

<dl>
 <dt><a href="/en-US/docs/Security_in_Firefox_2">Security in Firefox 2</a></dt>
 <dd>Firefox 2 has changes to which security protocols are enabled by default.</dd>
</dl>

<h3 id="For_XUL_and_extension_developers">For XUL and extension developers</h3>

<dl>
 <dt><a href="/en-US/docs/Updating_extensions_for_Firefox_2">Updating extensions for Firefox 2</a></dt>
 <dd>Covers how to get your existing extensions to work with Firefox 2.</dd>
 <dt><a href="/en-US/docs/Session_store_API">Session store API</a></dt>
 <dd>Contributing items to be saved and restored across sessions in Firefox.</dd>
 <dt><a href="/en-US/docs/Feed_content_access_API">Feed content access API</a></dt>
 <dd>API that lets developers access and parse RSS and Atom feeds.</dd>
 <dt><a href="/en-US/docs/SAX">SAX support</a></dt>
 <dd>Event-based XML parser API.</dd>
 <dt><a href="/en-US/docs/Adding_search_engines_from_web_pages">Adding search engines from web pages</a></dt>
 <dd>JavaScript code can instruct Firefox to install a new search engine plugin, which can be written using either OpenSearch or Sherlock format.</dd>
 <dt><a href="/en-US/docs/Using_spell_checking_in_XUL">Using spell checking in XUL</a></dt>
 <dd>How to check the spelling of words or get a list of suggested spellings from code.</dd>
 <dt><a href="/en-US/docs/Adding_phishing_protection_data_providers">Adding phishing protection data providers</a></dt>
 <dd>It's possible to enhance Firefox's phishing protection by adding additional data providers for the safe browsing system.</dd>
 <dt><a href="/en-US/docs/Adding_feed_readers_to_Firefox">Adding feed readers to Firefox</a></dt>
 <dd>You can add new feed readers to Firefox, whether web-based or application-based.</dd>
 <dt><a href="/en-US/docs/Storage">Storage</a></dt>
 <dd>Firefox 2 introduces mozStorage, an sqlite based database architecture.</dd>
 <dt><a href="/en-US/docs/Theme_changes_in_Firefox_2">Theme changes in Firefox 2</a></dt>
 <dd>Discusses the changes needed to update existing themes to work in Firefox 2.</dd>
 <dt>Textbox Improvements (Firefox 2.0.0.1 and higher only)</dt>
 <dd>The <code>&lt;textbox&gt;</code> now has a <code>reset()</code> method to reset the value of the textbox to the default value. The <code>defaultValue</code> property may be used to retrieve and modify the default value of the textbox ({{Bug(312867)}}).</dd>
 <dd>Supports an <code>editor</code> property to get the internal <a href="/en-US/docs/NsIEditor">nsIEditor</a> for the text field ({{Bug(312867)}}).</dd>
</dl>

<h2 id="New_features_for_end_users">New features for end users</h2>

<p>Firefox 2 provides an enhanced version of the same clean user interface offered by previous versions, with improved security features to make your online experience safer and more convenient than ever.</p>

<h3 id="User_experience">User experience</h3>

<ul>
 <li><strong>Inline spell checking for text areas</strong> lets you compose with confidence in web forms.</li>
 <li><strong>Microsummaries</strong> provide a way to create bookmarks that display information pulled from the site they refer to, updated automatically. Great for stock tickers, auction monitoring, and so forth.</li>
 <li><strong>Extension Manager user interface</strong> has been enhanced.</li>
 <li><strong>Search engine manager</strong> lets you rearrange and remove search engines shown in the search bar.</li>
 <li><strong>Tabbed browsing enhancements</strong> include adding close buttons to each tab, adjustments to how Firefox decides which tab to bring you to when you close the current tab, and simplified preferences for tabs.</li>
 <li><strong>Autodetection of search engines</strong> allows search engines that offer plugins for the Firefox search bar to offer to install their plugins for you.</li>
 <li><strong>Search suggestions</strong> allow search engines to offer suggested search terms based on what you've typed so far in the search bar.</li>
</ul>

<h3 id="Security_and_privacy">Security and privacy</h3>

<ul>
 <li><strong>Phishing Protection</strong> to warn users when the web site you're looking at appears to be a forgery.</li>
</ul>

<h2 id="See_also">See also</h2>

<div>{{Firefox_for_developers('2')}}</div>
